<template>
  <div id="app">

    <nav>
      <div class="nav-wrapper blue darken-1">
        <a href="#" class="brand-logo center">Tipos</a>
      </div>
    </nav>

    <div class="container">

      <ul>
          <li v-for="(erro, index) of errors" :key="index"> 
              campo <b> {{ erro.field }} - {{ erro.defaultMessage }} </b>
          </li>
      </ul>

      <form @submit.prevent="salvar">

          <label>Tipo</label>
          <input type="text" placeholder="Tipo" v-model="tipo.descricao">

          <button class="waves-effect waves-light btn-small">Salvar<i class="material-icons left">save</i></button>

      </form>

      <table>

        <thead>

          <tr>
            <th>TIPO</th>
            <th>OPÇÕES</th>
          </tr>

        </thead>

        <tbody>

          <tr v-for="tipo of tipos" :key="tipo.id">

            <td> {{ tipo.descricao }} </td>
            <td>
              <button @click="editar(tipo)" class="waves-effect btn-small blue darken-1"><i class="material-icons">create</i></button>
              <button @click="remover(tipo)" class="waves-effect btn-small red darken-1"><i class="material-icons">delete_sweep</i></button>
            </td>

          </tr>

        </tbody>
      
      </table>

    </div>

  </div>
</template>

<script>

import Tipo from '../service/tipos'

export default {

  data(){
    return {
      tipo: {
        id: '',
        descricao: ''
      },

      tipos: [],
      errors: []
    }
  },

  mounted(){
      this.listar()
    },

  methods: {
    listar() {
    Tipo.listar().then(resposta => {
      this.tipos = resposta.data
    })
  },

  salvar () {
      if(!this.tipo.id){
        Tipo.salvar(this.tipo).then(resposta => {
          this.tipo = {}
          alert('Tipo salvo com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }else{
      Tipo.atualizar(this.tipo).then(resposta => {
          this.tipo = {}
          alert('Tipo atualizado com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }

  },

  editar(tipo){
    this.tipo = tipo
  },

  remover(tipo){
    if(confirm('Deseja excluir esse tipo?')){
      Tipo.apagar(tipo).then(resposta => {
        this.listar();
        this.errors = []
      }).catch(e => {
        this.errors = e.response.data.errors
      })
    }
  }
}
}

</script>